METIS = 1

#==============================================================================
# Fichiers C++
#==============================================================================
cpp_srcs = ["Transform/coordTransform.cpp",
            "Transform/deform.cpp",
            "Transform/deform2.cpp",
            "Transform/deformMeshStruct.cpp",
            "Transform/rotate.cpp",
            "Transform/translate.cpp",
            "Transform/perturbate.cpp",
            "Transform/patch.cpp",
            "Transform/oneovern.cpp",
            "Transform/reorder.cpp",
            "Transform/subzone.cpp",
            "Transform/subzoneInt.cpp",
            "Transform/join.cpp",
            "Transform/joinBoth.cpp",
            "Transform/joinAll.cpp",
            "Transform/splitCurvatureAngle.cpp",
            "Transform/splitCurvatureRadius.cpp",
            "Transform/splitConnexity.cpp",
            "Transform/splitBAR.cpp",
            "Transform/splitTBranches.cpp",
            "Transform/splitTRI.cpp",
            "Transform/splitSharpEdges.cpp",
            "Transform/addkplane.cpp",
            "Transform/reorderAll.cpp",
            "Transform/reorderAllUnstr.cpp",
            "Transform/projectDir.cpp",
            "Transform/projectOrtho.cpp",
            "Transform/projectOrthoSmooth.cpp",
            "Transform/projectRay.cpp",
            "Transform/projectSmoothDir.cpp",
            "Transform/smooth.cpp",
            "Transform/collapse.cpp",
            "Transform/mergeCartGrids.cpp",
            "Transform/mergeStructGrids.cpp",
            "Transform/computeDeformationVector.cpp",
            "Transform/breakNGonElements.cpp",
            "Transform/splitNGon.cpp",
            "Transform/dual.cpp",
            "Transform/projectAllDirs.cpp",
            "Transform/splitManifold.cpp",
            "Transform/cart2Cyl.cpp",
            "Transform/cyl2Cart.cpp"
            ]

if METIS == 1:
    cpp_srcs += ['Transform/Metis/auxapi.c',
                 'Transform/Metis/b64.c',
                 'Transform/Metis/balance.c',
                 'Transform/Metis/blas.c',
                 'Transform/Metis/bucketsort.c',
                 'Transform/Metis/checkgraph.c',
                 'Transform/Metis/coarsen.c',
                 'Transform/Metis/compress.c',
                 'Transform/Metis/contig.c',
                 'Transform/Metis/csr.c',
                 'Transform/Metis/debug.c',
                 'Transform/Metis/error.c',
                 'Transform/Metis/evaluate.c',
                 'Transform/Metis/fkvkselect.c',
                 'Transform/Metis/fm.c',
                 'Transform/Metis/fortran.c',
                 'Transform/Metis/frename.c',
                 'Transform/Metis/fs.c',
                 #'Transform/Metis/getopt.c',
                 'Transform/Metis/gklib.c',
                 #'Transform/Metis/gkregex.c',
                 'Transform/Metis/gkgraph.c',
                 'Transform/Metis/gkutil.c',
                 'Transform/Metis/graph.c',
                 'Transform/Metis/htable.c',
                 'Transform/Metis/initpart.c',
                 'Transform/Metis/io.c',
                 'Transform/Metis/itemsets.c',
                 'Transform/Metis/kmetis.c',
                 'Transform/Metis/kwayfm.c',
                 'Transform/Metis/kwayrefine.c',
                 'Transform/Metis/mcore.c',
                 'Transform/Metis/mcutil.c',
                 'Transform/Metis/memory.c',
                 'Transform/Metis/mesh.c',
                 'Transform/Metis/meshpart.c',
                 'Transform/Metis/minconn.c',
                 'Transform/Metis/mincover.c',
                 'Transform/Metis/mmd.c',
                 'Transform/Metis/ometis.c',
                 'Transform/Metis/omp.c',
                 'Transform/Metis/options.c',
                 'Transform/Metis/parmetis.c',
                 'Transform/Metis/pdb.c',
                 'Transform/Metis/pmetis.c',
                 'Transform/Metis/pqueue.c',
                 'Transform/Metis/random.c',
                 'Transform/Metis/refine.c',
                 'Transform/Metis/rw.c',
                 'Transform/Metis/separator.c',
                 'Transform/Metis/seq.c',
                 'Transform/Metis/sfm.c',
                 'Transform/Metis/sort.c',
                 'Transform/Metis/srefine.c',
                 'Transform/Metis/stat.c',
                 'Transform/Metis/string.c',
                 'Transform/Metis/timers.c',
                 'Transform/Metis/timing.c',
                 'Transform/Metis/tokenizer.c',
                 'Transform/Metis/util.c',
                 'Transform/Metis/wspace.c'
                 ]

#==============================================================================
# Fichiers fortran
#==============================================================================
for_srcs = ['Transform/Fortran/RotateF.for',
            'Transform/Fortran/HomothetyF.for',
            'Transform/Fortran/DeformF.for' ]
